local hornwarning = CV_RegisterVar({ -- initial warning threshold for horn spam
	name = "hornwarning",
	defaultvalue = "13",
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})
local horndanger = CV_RegisterVar({ -- secondary warning threshold for horn spam
	name = "horndanger",
	defaultvalue = "18",
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})
local hornlethal = CV_RegisterVar({ -- this many consecutive horns kills you
	name = "hornlethal",
	defaultvalue = "25", --setting this to 1 is considered unfriendly
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})
local hornwarningreset = CV_RegisterVar({ -- time required for horn warning to reset
	name = "hornwarningreset",
	defaultvalue = "5",
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})
local hornobnoxious = CV_RegisterVar({ -- instead of getting shadowbanned from horns, you blow up
	name = "hornobnoxious",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornfinaldeath = CV_RegisterVar({ -- if true, you time over when horn exploding
	name = "hornfinaldeath",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornattenuate = CV_RegisterVar({ -- amount to shift horn origin for post-race nonwinning players (reduces volume)
	name = "hornattenuate",
	defaultvalue = "4000",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local horntypeoverride = CV_RegisterVar({ -- override horn for all players
	name = "horntypeoverride",
	defaultvalue = "0",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local horntypechaos = CV_RegisterVar({ -- I CAN DO ANYTHING
	name = "horntypechaos",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornshowhelptext = CV_RegisterVar({ -- if you're forcing horns, you can turn off command help to make things cleaner
	name = "hornshowhelptext",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornshowtutorial = CV_RegisterVar({ -- friendmod conflicts, wheeee
	name = "hornshowtutorial",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornmaxexplosions = CV_RegisterVar({ -- autokick people who are really funny
	name = "hornmaxexplosions",
	defaultvalue = "10",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local horndebug = CV_RegisterVar({ -- spam console
	name = "horndebug",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornvisual = CV_RegisterVar({ -- color flash when horns are triggered
	name = "hornvisual",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horntattle = CV_RegisterVar({ -- information for admins, less intrusive than debug
	name = "horntattle",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornexplosions = CV_RegisterVar({ -- information for admins, less intrusive than debug
	name = "hornexplosions",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornhell = CV_RegisterVar({ -- do you want terrible horns on terrible maps?
	name = "hornhell",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornhellchance = CV_RegisterVar({ -- do you want terrible horns entirely at random?
	name = "hornhellchance",
	defaultvalue = 5,
	flags = CV_NETVAR,
	possiblevalue = {MIN = 0, MAX = 1000}
})
local hornduelmode = CV_RegisterVar({ -- disable lethal threshold if 1v1
	name = "hornduelmode",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hornenabled = CV_RegisterVar({ -- local override if you hate fun
	name = "hornenabled", -- may desync if changed in realtime?
	defaultvalue = "On", -- also you still die if you breach hornlethal lol
	possiblevalue = CV_OnOff -- don't complain
})

local versionname = '4 - "NEO HORNMOD DELUXE"'
local starttime = 6 * TICRATE + (3 * TICRATE / 4)

freeslot("sfx_hmwarn")
freeslot("sfx_hmdang")
freeslot("sfx_hmslct")
freeslot("sfx_hmhell")
freeslot("sfx_hmstop") -- unused FOR NOW...

freeslot("MT_HAHALOUD")
freeslot("S_LOUD")
freeslot("SPR_HORN")

mobjinfo[MT_HAHALOUD] = {
	spawnstate = S_LOUD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

states[S_LOUD] = {
	sprite = SPR_HORN
}


local horns = { -- extags are invisible but searched via horntype
	{name = "sfx_hbd2dx", info = "Eu tambem"},
	{name = "sfx_hbdalp", info = "NHAUMAUUM, da quele jeito"},
	{name = "sfx_hbdcap", info = "Credit - Marvel vs. Capcom 2"},
	{name = "sfx_hbdneo", info = "Credit - Neo Geo"},
	{name = "sfx_hbdcrz", info = "Credit - Marvel vs. Capcom"},
	{name = "sfx_hbdtrk", info = "Fire truck horn - Daniel Simon"},
	{name = "sfx_hbdwoo", info = "WOO"},
	{name = "sfx_hbdtro", info = "Trophy - Super Smash Bros. Melee"},
	{name = "sfx_hbdjoy", info = "Symbol art SFX - Phantasy Star Online"},
	{name = "sfx_hbdtge", info = "/toge!!!! - Phantasy Star Online"},
	{name = "sfx_hbdgal", info = "Extend - Galaga"},
	{name = "sfx_hbdtgm", info = "Credit - Tetris The Grandmaster 2"},
	{name = "sfx_hbdez", info = "EASY"},
	{name = "sfx_hbdsf2", info = "Credit - Street Fighter II"},
	{name = "sfx_hbde37", info = "Parry - Street Fighter III: Third Strike"},
	{name = "sfx_hbdsfa", info = "Credit - Street Fighter Alpha 3"},
	{name = "sfx_hbdpsi", info = "Credit - Strikers 1945"},
	{name = "sfx_hbdovr", info = "Overhead!"},
	{name = "sfx_hbdyoo", info = "YOOOOOOooooOOOOOOOOOO~", extags = "kabuki"},
	{name = "sfx_hbdvsv", info = "Credit - Vampire Savior"},
	{name = "sfx_hbdddr", info = "Select - Dance Dance Revolution"},
	{name = "sfx_hbdmvl", info = "Menu SFX - Marvel vs. Capcom 2"},
	{name = "sfx_hbdwii", info = "Wii Menu"},
	{name = "sfx_hbdkya", info = "Menu SFX? - Ultra Fight Kyanta 2"},
	{name = "sfx_hbderr", info = "Windows XP Error"},
	{name = "sfx_hbdmem", info = "La Cucaracha horn - Microsoft Plus! for Windows 95"},
	{name = "sfx_hbdnop", info = "Awful truck horn - Microsoft Plus! for Windows 95"},
	{name = "sfx_hbdair", info = "A I R H O R N", extags = "airhorn"},
	{name = "sfx_hbdfut", info = "FOOT DIVE - Marvel vs. Capcom 3"},
	{name = "sfx_hbdtig", info = "TIGER - Street Fighter II"},
	{name = "sfx_hbdgrd", info = "Gained Vorpal - Under Night In-Birth", extags = "unist"},
	{name = "sfx_hbdgcn", info = "GameCube startup"},
	{name = "sfx_hbdday", info = "Some horn I ripped from sound test - Daytona USA 2"},
	{name = "sfx_hbddma", info = "Credit - Dimahoo"},
	{name = "sfx_hbdcll", info = "Calling for a Ride - Kirby and the Amazing Mirror"},
	{name = "sfx_hbdmic", info = "CHESTOOOOOOO - Kirby Super Star"},
	{name = "sfx_hbdmir", info = "Mirror Kirby Appears - Kirby and the Amazing Mirror"},
	{name = "sfx_hbdesc", info = "WELL DONE - ESCHATOS"},
	{name = "sfx_hbddng", info = "ding~ - Fire Emblem"},
	{name = "sfx_hbdlvl", info = "Gained Stats - Fire Emblem"},
	{name = "sfx_hbdfe0", info = "Menu Selection - Fire Emblem"},
	{name = "sfx_hbdfe1", info = "Level Up - Fire Emblem"},
	{name = "sfx_hbdgo", info = "LET'S GO - Alien Soldier"},
	{name = "sfx_hbdthk", info = "Thok - Sonic Robo Blast 2"},
	{name = "sfx_hbdwow", info = "WOW - Super Smash Bros. Melee"},
	{name = "sfx_hbd2dx", info = "SOMEBODY SCREEEEEEEEEEEEEEEAM", extags = "somebody scream"},
	{name = "sfx_hbdqc", info = "Low HP (B.J. Blaskowicz) - Quake Champions"},
	{name = "sfx_hbdaou", info = "AEIOU - Moonbase Alpha"},
	{name = "sfx_hbdtga", info = "HA HA HA HA HA - Ultraman Tiga"},
	{name = "sfx_hbdzor", info = "Z0R - modacity.avi"},
	{name = "sfx_hbdpar", info = "??? - PARANOiA MAX (DIRTY MIX)"},
	{name = "sfx_hbddst", info = "NICE KICK IDIOT"},
	{name = "sfx_hbdaaa", info = "AAAAAAAAA - Rainbow Six Siege"},
	{name = "sfx_hbdbrh", info = "bruh"},
	{name = "sfx_hbdgsp", info = "(gasp) - Shadowverse"},
	{name = "sfx_hbdkrb", info = "Blayrouzer Card Swipe - Kamen Rider Blade"},
	{name = "sfx_hbdhlo", info = "HELLO - Dragonball FighterZ"},
	{name = "sfx_hbdwar", info = "WARIO LAUGHING"},
	{name = "sfx_hbdskl", info = "SKULL TRUMPET", extags = "doot"},
	{name = "sfx_hbdcmo", info = "COME ON! - Sonic 3"},
	{name = "sfx_hbdwsc", info = "Wii Shop Channel"},
	{name = "sfx_hbdfox", info = "*blip* - Super Smash Bros. Melee", extags = "shine"},
	{name = "sfx_hbdseg", info = "SEGA! - Sonic 3D Blast"},
	{name = "sfx_hbdspn", info = "Warning - Sonic Spinball"},
	{name = "sfx_hbdmag", info = "Credit - Magical Drop 3"},
	{name = "sfx_hbdwil", info = "Wilhelm Scream"},
	{name = "sfx_hbdhrn", info = "Literally a stock car horn sound effect"},
	{name = "sfx_hbdtom", info = "KHARACTER - Tom Brady (the other one)"},
	{name = "sfx_hbds4l", info = "Critical! - S4 League"},
	{name = "sfx_hbdsnr", info = "St. Anger Snare - Metallica"},
	{name = "sfx_hbdnce", info = "Nice - Dictionary.com"},
	{name = "sfx_hbdfe2", info = "Item Get - Fire Emblem: Genealogy of the Holy War"},
	{name = "sfx_hbdger", info = "Geronimo! (War Machine) - Marvel vs. Capcom"},
	{name = "sfx_hbddhd", info = "Humiliating Failure - Duck Hunt"},
	{name = "sfx_hbdmj", info = "WOW - Michael Jackson's Moonwalker"},
	{name = "sfx_hbdmeo", info = "Meow - Mario Paint"},
	{name = "sfx_hbdmac", info = "The Loudest Sound Ever Recorded - Apple"},
	{name = "sfx_hbdzr0", info = "Select - ZeroRanger"},
	{name = "sfx_hbdzr1", info = "WARNING - ZeroRanger"},
	{name = "sfx_hbdngn", info = "You don't have that gun, idiot - ZeroRanger"},
	{name = "sfx_hbdzr3", info = "Extend - ZeroRanger"},
	{name = "sfx_hbdbay", info = "Platinum Coin - Bayonetta 2"},
	{name = "sfx_hbdeas", info = "E - A Sports"},
	{name = "sfx_hbdbss", info = "*BASS~* - Bassline Yatteru? w"},
	{name = "sfx_hbdok", info = "Ooooookay! - Dance Dance Revolution"},
	{name = "sfx_hbdwao", info = "wao - Dance Dance Revolution", extags = "wow"},
	{name = "sfx_hbdpy0", info = "Round Start - Puyo Puyo Tetris"},
	{name = "sfx_hbdpy1", info = "Select - Puyo Puyo Tetris"},
	{name = "sfx_hbd3ch", info = "3 Chain - Tetris Attack"},
	{name = "sfx_hbdexs", info = "Shield - Melty Blood"},
	{name = "sfx_hbdbip", info = "[beeps in Japanese] - Melty Blood"},
	{name = "sfx_hbdnec", info = "[incomprehensible yodeling] - Street Fighter III: Third Strike", extags = "necro"},
	{name = "sfx_hbdmbn", info = "Counter Hit! - Megaman Battle Network"},
	{name = "sfx_hbdtcg", info = "Get Booster Pack - Pokemon Trading Card Game"},
	{name = "sfx_hbdehr", info = "BWEEEEEEEEEEoooooooowwwwwwwww - Ehrgeiz"},
	{name = "sfx_hbdalp", info = "Credit - Alpine Racer 2"},
	{name = "sfx_hbdhd2", info = "RELOAD! - The House of the Dead 2"},
	{name = "sfx_hbdnxt", info = "I Piece Next - Tetris The Grandmaster 3"},
	{name = "sfx_hbdlp", info = "LIGHT PUNCH - Iron Man Infinite Tutorial"},
	{name = "sfx_hbdmor", info = "Good Morning - Tekken 3"},
	{name = "sfx_hbdmke", info = "Select - Skullgirls"},
	{name = "sfx_hbdslm", info = "WOOSH - Sound Voltex"},
	{name = "sfx_hbddis", info = "Discoman! - Dangun Feveron"}, -- HORNMOD 2: Lord of Destruction
	{name = "sfx_hbdbn0", info = "ding dong~ - Megaman Battle Network"},
	{name = "sfx_hbdxi0", info = "<se.3> - Final Fantasy XIV: A Realm Reborn", extags = "ffxiv"},
	{name = "sfx_hbdmga", info = "You already know what this is", extags = "megalovania"},
	{name = "sfx_hbdsat", info = "Mr. Saturn - Super Smash Bros. Melee"},
	{name = "sfx_hbdalt", info = "Alert - Metal Gear Solid"},
	{name = "sfx_hbdshl", info = "Kicked Shell - Super Mario Bros."},
	{name = "sfx_hbdmax", info = "MAXIMUM! - Ultimate Marvel vs. Capcom 3", extags = "umvc3"},
	{name = "sfx_hbddud", info = "dude - Ultimate Marvel vs. Capcom 3", extags = "umvc3"},
	{name = "sfx_hbdxf", info = "X-Factor Activated - Ultimate Marvel vs. Capcom 3", extags = "umvc3"},
	{name = "sfx_hbdcom", info = "Completion - Super Smash Bros."},
	{name = "sfx_hbdmb2", info = "Continue - Super Monkey Ball 2"},
	{name = "sfx_hbduni", info = "New Challenger - Under Night In-Birth", extags = "unist"},
	{name = "sfx_hbdmld", info = "Credit - Magician Lord"},
	{name = "sfx_hbdtec", info = "Credit - Tecmo World Soccer '96"},
	{name = "sfx_hbdtoa", info = "Toa (East Asia) - Dodonpachi Dai-Ou-Jou"},
	{name = "sfx_hbd999", info = "Credit - Strikers 1999"},
	{name = "sfx_hbdcrs", info = "Power Up - Cho Ren Sha 68k"},
	{name = "sfx_hbdacc", info = "Aircraft Carrier - Gradius"},
	{name = "sfx_hbdfof", info = "Credit - Jackie Chan in Fists of Fire"},
	{name = "sfx_hbdgwa", info = "Credit - Guwange"},
	{name = "sfx_hbdswt", info = "Deeply Satisfying Click - Nintendo Switch"},
	{name = "sfx_hbdthw", info = "Thwomp - Super Mario 64"},
	{name = "sfx_hbdpsn", info = "Trophy - PlayStation 4", extags = "ps4"},
	{name = "sfx_hbddmn", info = "Credit - Dunk Mania"},
	{name = "sfx_hbdhyd", info = "Select - Hydro Thunder"},
	{name = "sfx_hbddgm", info = "Quack - Duck Game"},
	{name = "sfx_hbdpty", info = "Party horn \o/"},
	{name = "sfx_hbduth", info = "Timed Hit - Undertale"},
	{name = "sfx_hbdbob", info = "Shoot - Puzzle Bobble"},
	{name = "sfx_hbddug", info = "oops - Dig Dug Arrangement"},
	{name = "sfx_hbdkar", info = "BALLOOOOOOOOOOOON - Karnov's Revenge", extags = "balloon"},
	{name = "sfx_hbdglr", info = "Result - Galaga Arrangement"},
	{name = "sfx_hbdpca", info = "Item Appears - Pac-Man Arrangement"},
	{name = "sfx_hbddok", info = "Data OK! - Tetris The Grand Master 3"},
	{name = "sfx_hbddcs", info = "Error - Sega Dreamcast"},
	{name = "sfx_hbdrun", info = "RUN - Sinistar"},
	{name = "sfx_hbdtny", info = "Special Trick - Tony Hawk's Pro Skater"},
	{name = "sfx_hbdgt3", info = "Select - Gran Turismo 3"},
	{name = "sfx_hbdbup", info = "bup"},
	{name = "sfx_hbdclp", info = "Assist Tick - Stepmania", extags = "clap"},
	{name = "sfx_hbdgba", info = "Startup - Game Boy Advance", extags = "gba"},
	{name = "sfx_hbdhey", info = "hey - Sonic 06"},
	{name = "sfx_hbdysh", info = "Yoshi Spit - Super Mario World"},
	{name = "sfx_hbdoht", info = "Orchestra Hit - Super Mario World"},
	{name = "sfx_hbdps2", info = "Logo - Playstation 2", extags = "ps2"},
	{name = "sfx_hbdpln", info = "*poke*"},
	{name = "sfx_hbdlno", info = "DUN DUN - Law and Order"},
	{name = "sfx_hbdwxp", info = "ding - Windows XP"},
	{name = "sfx_hbdoah", info = "OOOOOOOOOAHHHHHHHHHHHH (Boxer) - Super Street Fighter II"},
	{name = "sfx_hbdasp", info = "A - E Sports"},
	{name = "sfx_hbdsou", info = "SOUND - PARANOIA MAX Dirty Mix"},
	{name = "sfx_hbdgtk", info = "Swap - Ghost Trick"},
	{name = "sfx_hbdkhe", info = "Error - Kingdom Hearts"},
	{name = "sfx_hbdrth", info = "Credit - Rolling Thunder 2"},
	{name = "sfx_hbdsub", info = "SUBALUWA", extags = "ed, edd and eddy"},
	{name = "sfx_hbdnpl", info = "Nice Play! - Super Smash Bros. Ultimate"},
	{name = "sfx_hbdfeh", info = "Friend Notice - Fire Emblem Heroes"},
	{name = "sfx_hbdusr", info = "User - Nintendo Switch"},
	{name = "sfx_hbdayy", info = ":D! - Super Mario Advance"},
	{name = "sfx_hbdsnb", info = "Select - Sonic Battle"},
	{name = "sfx_hbdrse", info = "Level Up - Pokemon Ruby/Sapphire"},
	{name = "sfx_hbd64s", info = "Stage Selected - Super Smash Bros."},
	{name = "sfx_hbdpkn", info = "Credit - Pokken Tournament"},
	{name = "sfx_hbdomg", info = "Credit - Omega Fighter"},
	{name = "sfx_hbdsrm", info = "Neutral - Marvel Vs. Capcom 2"},
	{name = "sfx_hbdknv", info = "Credit - Karnov's Revenge"},
	{name = "sfx_hbdssx", info = "Multiplier - SSX"},
	{name = "sfx_hbdnc2", info = "Nice - Ultimate Marvel vs. Capcom 3"},
	{name = "sfx_hbdx", info = "X - X-Men: Children of the Atom"},
	{name = "sfx_hbddcc", info = "Confirm - Sega Dreamcast"},
	{name = "sfx_hbdfrn", info = "Extra - Fast Racing NEO"},
	{name = "sfx_hbdgtr", info = "I have no idea - Gunstar Heroes"},
	{name = "sfx_hbdaim", info = "Card OK - Aime"},
	{name = "sfx_hbdsav", info = "Score Tally - Space Invaders Extreme 2"},
	{name = "sfx_hbdrid", info = "Select - Sonic Riders"},
	{name = "sfx_hbdmkc", info = "Confirm - Mortal Kombat: Complete Edition"},
	{name = "sfx_hbdsvc", info = "Select - SvC Chaos"},
	{name = "sfx_hbdhh1", info = "ahaha.wav - Umineko"}, -- DON'T ASK ME FOR SHIT ZXY
	{name = "sfx_hbdmmx", info = "You tell me - Megaman X"},
	{name = "sfx_hbdswp", info = "Swap Combo - Puyo Puyo Tetris"},
	{name = "sfx_hbdsty", info = "Stylish! - Paper Mario: The Thousand-Year Door"},
	{name = "sfx_hbdmnk", info = "[MONKEY NOISES] - Donkey Kong Country"},
	{name = "sfx_hbdmss", info = "Miss! - Mario Party"},
	{name = "sfx_hbdg", info = "G - Dictionary.com"},
	{name = "sfx_hbdctf", info = "Consider the following - Phoenix Wright: Ace Attorney"},
	{name = "sfx_hbdprd", info = "PREDICTABO - Capcom vs. SNK 2"},
	{name = "sfx_hbddvd", info = "DEE VEE DEE", extags = "dvd"},
	{name = "sfx_hbdsqu", info = "*squeak*"},
	{name = "sfx_hbdoof", info = "oof - Roblox"},
	{name = "sfx_hbdxps", info = "Shutdown - Windows XP"},
	{name = "sfx_hbdwtd", info = "The pinnacle of comedy", extags = "seinfeld"},
	{name = "sfx_hbdhhf", info = "Scorpion being mad"},
	{name = "sfx_hbdgm6", info = "Really bad explosion - Game Maker"},
	{name = "sfx_hbdwat", info = "What. - Soulcalibur II"},
	{name = "sfx_hbdfgx", info = "Danger! - F-Zero GX"},
	{name = "sfx_hbdinc", info = "BWAH - Inception"},
	{name = "sfx_hbdbtr", info = "Betrayal. - Halo 3"},
	{name = "sfx_hbdblj", info = "Yahoo! - Super Mario 64"},
	{name = "sfx_hbdbrk", info = "WHAT? - some dude who gets mad at ramps", extags = "barkley"},
}

local hellhorns = { -- OH NOOOOOOOOOOO
	{name = "sfx_hbdhh2", info = ":pingsock:"},
	{name = "sfx_hbdhh3", info = "BEE SAYVENTEEN BAWMBER"},
	{name = "sfx_hbdhh4", info = "The Sound Of Not Having Ice Cream Anymore"},
	{name = "sfx_hbdhh5", info = "ULTRAWHALE"},
	{name = "sfx_hbdhh6", info = "GOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOLD"},
	{name = "sfx_hbdhh7", info = "WOOOOOOOOOOOO~"},
	{name = "sfx_hbdhh8", info = "T H E B E A M"},
	{name = "sfx_hbdhh9", info = "[toad noises]"},
	{name = "sfx_hbdhha", info = "win"},
	{name = "sfx_hbdhhb", info = "LOUD EASY"},
	{name = "sfx_hbdhhc", info = "airhorn: the sequel"},
	{name = "sfx_hbdhhd", info = "The Wario Engine"},
	{name = "sfx_hbdhhe", info = "Part of a complete breakfast."},
	{name = "sfx_hbdhhg", info = "JOKE"},
	{name = "sfx_hbdhhh", info = "man screams at yellow paint"},
	{name = "sfx_hbdhhi", info = "HAPPY SET :D"},
	{name = "sfx_hbdhhj", info = "vegeta.wav"},
	{name = "sfx_hbdhhk", info = "M A C H I N E  G U N ."},
	{name = "sfx_hbdhhl", info = "sasoribi"},
	{name = "sfx_hbdhhm", info = "bisonyes.wav"},
	{name = "sfx_hbdhhn", info = "ain't nothin' like a good mountain dew"},
	{name = "sfx_hbdhho", info = "AAAAAAAAYYYYYY"},
	{name = "sfx_hbdhhp", info = "lavos stop that"},
	{name = "sfx_hbdhhq", info = "godzilla stop that"},
	{name = "sfx_hbdhhr", info = "******* stop that"},
}

local function ks_countplayers()
	local pnum = 0
	for p in players.iterate
		if p.spectator then continue end -- dont count specators
		pnum = $+1
	end
	return pnum
end

local function hornlog(p,q) -- for debug fuckery
	if horndebug.value then
		print(p.name .. " | " .. q)
	end
end

local function tattle(p,q) -- for clandestine admin shenanigans
	if not horntattle.value then
		return
	end
	for h in players.iterate do
		if IsPlayerAdmin(h) then
			CONS_Printf(h, "\134" .. p.name .. " | " .. q)
		end
	end
end

local function allocatenewhorn(name)
	if not _G[name] then
		freeslot(name)
		sfxinfo[_G[name]].flags = SF_X4AWAYSOUND
	else
		print(name .. " already allocated, distance flag will be wrong!")
	end
end

for k, v in ipairs(horns) do
	allocatenewhorn(v.name)
end

for k, v in ipairs(hellhorns) do
	allocatenewhorn(v.name)
end

local function horninit(p) -- zero everything and reload horn type
	hornlog(p,"initializing")
	p.hornready = 1 -- are we initialized
	p.horncount = 0 -- times we've hit horn recently
	p.sincelasthorn = 0 -- resets horncount when you back off
	p.lastframeitem = 0 -- haha we tick after gamestate updates...
	p.lastframeroulette = 0 -- ...so all item box state has to be snapshotted from the previous frame...
	p.lastframeheld = 0 -- ...every...
	p.lastframeeggmanheld = 0 -- ...single...
	p.lastframesneaker = 0 -- ...flag
	p.horninput = 0 -- how long has the horn button been down
	p.hornflash = 0 -- frames to flash as a visual horn indicator
	p.finishedfor = 0 -- how long have we been finished (used for help text)
	p.sincelastwarning = 0 -- if you repeatedly breach the limit, you start losing it
	p.shutupidiot = 0 -- adjusts spam reset timer up the more times you trigger it
	p.warningstate = 0 -- one warning sound per warning state, thanks
	p.noisemaker = nil -- invisible hornbox so that stopsound doesn't kill engine noise
	p.markedfordeath = false -- when you leave spin state with this true, you die
	p.alreadyexploded = false -- limits the number of lethal horn explosions that can be generated, loose antigrief measure
	p.lifetimehorncount = $ or 0 -- used for "PRESS ITEM" control prompt
	p.lifetimeexplodecount = 0 -- automatically handle extremely funny players
	p.targethorntype = $ or 0 -- the horn the player has set (not the one they were assigned)
	p.usinghellhorns = false -- clearly labeled
	p.shakefactor = 0 -- rapid mash for agitated icon
	if p.helpme == nil then -- hide help text if you already know what you're doing
		p.helpme = true
	end
	p.mo.color = p.skincolor -- just in case someone was on a flash frame during a weird exit
	
	p.horntype = P_RandomRange(1, #horns)
	if p.targethorntype > 0 then -- if we have a set horn, use it
		p.horntype = p.targethorntype
	end
	if p.favoredhorns and p.targethorntype == -1 then -- magic number for favored horns
		p.horntype = p.favoredhorns[P_RandomRange(1, #p.favoredhorns)]
	end
end

local function spawnnoisemaker(p) -- immortal invisible noclip thok
	p.noisemaker = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_HAHALOUD)
	p.noisemaker.tics = -1
	-- v2 deletes hornmod so i do not care about this code anymore
	p.hacknoisemaker = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
	p.hacknoisemaker.state = S_INVISIBLE
	p.hacknoisemaker.tics = -1
	p.hacknoisemaker.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
end

local function prettyhornname(h) -- nicely formatted horn information. pass it an index
	return "\135#" .. h .. ": \130" .. horns[h].info
end

local function sethorn(p, h) -- believe it or not, this is cleaner than what was here before
	if h == nil then -- why
		hornlist(p)
		return
	end
	if h == -1 then -- keep current
		if p.horntype then
			p.targethorntype = p.horntype
			p.helpme = false
			hornlog(p,"keephorn ok")
			tattle(p,"keep: " .. prettyhornname(p.horntype))
			S_StartSound(nil, _G[horns[p.targethorntype].name], p)
			S_StartSound(nil, sfx_hmslct, p)
			return "\131OK! \128You will keep your current horn, " .. prettyhornname(p.horntype) .. "\128.\nUse \135resethorn\128 to return to random horns."
		else
			hornlog(p,"keephorn spec?")
			return "\133You don't have a horn set. Join the race first!"
		end
	end
	if h == 0 then -- clear preference
		p.targethorntype = 0
		hornlog(p,"fixedhorn off")
		tattle(p,"return to random")
		S_StartSound(nil, sfx_hmslct, p)
		return "\131OK! \128Cleared your horn preference. Your next horn will be random."
	end
	if h > 0 and h <= #horns then -- index
		hornlog(p,"sethorn valid")
		p.helpme = false
		p.targethorntype = h
		tattle(p,"set explicit: " .. prettyhornname(p.targethorntype))
		S_StartSound(nil, _G[horns[p.targethorntype].name], p)
		S_StartSound(nil, sfx_hmslct, p)
		if leveltime > starttime and p.mo then
			return "\131OK! \128Your horn will be " .. prettyhornname(p.targethorntype) .. "\128 for the next race.\nUse \135resethorn\128 to return to random horns."
		else
			p.horntype = h
			return "\131OK! \128Set your horn to " .. prettyhornname(p.targethorntype) .. "\128.\nUse \135resethorn\128 to return to random horns."
		end
	else -- index out of range
		hornlog(p,"sethorn invalid")
		return "\133Out of range. \128Try a number between 1 and " .. #horns .. ", or use \135listhorns\128."
	end
end

local function hornlist(p, i) -- prints all horn information to console
	local guard = tonumber(i) or 1
	local rangehelp = ""
	local pagesize = 20
	local adjust = 0 -- does srb2 lua have ceiling()????
	if #horns % pagesize then
		adjust = 1
	end
	if guard < 0 or guard > (#horns / pagesize + adjust) then
		guard = 1
		rangehelp = " \134(ignored your page number, out of range)"
	end
	local pagedivider = "\134=== Page \130" .. guard .. " \134of \130" .. (#horns/pagesize + adjust) .. " \134===" .. rangehelp
	guard = $ - 1
	local lowbound = guard * pagesize + 1
	local highbound = min(#horns, guard * pagesize + pagesize)
	CONS_Printf(p, pagedivider)
	for h = lowbound, highbound do
		CONS_Printf(p, prettyhornname(h))
	end
	CONS_Printf(p, pagedivider)
	CONS_Printf(p, "Try something like \135listhorns 3\128, \135sethorn 42\128 or \135sethorn galaga\128.")
	tattle(p,"list: " .. guard)
end
COM_AddCommand("hornlist", hornlist)
COM_AddCommand("listhorns", hornlist)

local function resethorn(p) -- returns a player's horn to random select
	CONS_Printf(p, sethorn(p, 0))
end
COM_AddCommand("resethorn", resethorn)
COM_AddCommand("hornreset", resethorn)
COM_AddCommand("randomhorn", resethorn)
COM_AddCommand("hornrandom", resethorn)

local function horntype(p, target, ...) -- sets horn by index or search
	hornlog(p,"horntype")
	if target == nil then -- no arg
		hornlog(p,"horntype nullguard")
		hornlist(p, target)
		return
	end
	local guard = tonumber(target)
	if guard == nil then -- NOT A NUMBER IDIOT
		hornlog(p,"horntype fuzzy?")
		local searchstring = string.lower(target)
		if ... then
			searchstring = searchstring .. " " .. string.lower(table.concat({...}, " "))
		end
		local searchresults = {}
		for k, v in ipairs(horns) do 
			if string.find(string.lower(v.info), searchstring) then
				table.insert(searchresults, k)
			elseif v.extags then -- supplementary information for when meme names are involved
				if string.find(v.extags, searchstring) then
					table.insert(searchresults, k)
				end
			end
		end
		if #searchresults == 1 then
			CONS_Printf(p, sethorn(p, searchresults[1]))
			return
		elseif #searchresults > 1 then
			for k, v in ipairs(searchresults) do
				CONS_Printf(p, prettyhornname(v))
			end
			CONS_Printf(p, "\133Multiple horns match \135" .. searchstring .. "\133. \128Could you be more specific?")
			return
		else
			CONS_Printf(p, "\133Couldn't find any horns matching \135" .. searchstring .. "\133.")
			return
		end
	end
	if ... then
		local favoredhorns = {guard}
		local validargs = true
		local packedargs = {...}
		for k, v in ipairs(packedargs)
			local nexthorn = tonumber(v)
			if nexthorn then
				if nexthorn > 0 and nexthorn <= #horns then
					table.insert(favoredhorns, nexthorn)
				else
					validargs = false
					break
				end
			else
				validargs = false
				break
			end
		end
		if validargs then
			p.favoredhorns = favoredhorns
			p.targethorntype = -1
			tattle(p,"set favored (someone actually used this!)")
			S_StartSound(nil, sfx_hmslct, p)
			CONS_Printf(p, "\131OK! \128Set your favored horns: they'll be randomly selected from at the start of every race.")
		else
			CONS_Printf(p, "\133Couldn't parse that. \128Try numbers between 1 and " .. #horns .. ".")
		end
	else
		CONS_Printf(p, sethorn(p, guard))
	end
end
COM_AddCommand("horntype", horntype)
COM_AddCommand("hornset", horntype)
COM_AddCommand("sethorn", horntype)

local function keephorn(p, target) -- locks in a player's current horn
	CONS_Printf(p, sethorn(p, -1)) -- LOL MAGIC NUMBERS
end
COM_AddCommand("keephorn", keephorn)
COM_AddCommand("hornkeep", keephorn)

local function hornsoff(p, target)
	COM_BufInsertText(p, "hornenabled off")
	p.nethornenabled = false
	CONS_Printf(p, "\131OK! \128Horns disabled. If you ever feel like having fun again, use \135hornson\128.")
	hornlog(p,"fun disabled")
	tattle(p,"horns off")
end
COM_AddCommand("hornsoff", hornsoff)
COM_AddCommand("hornoff", hornsoff)
COM_AddCommand("disablehorn", hornsoff)
COM_AddCommand("disablehorns", hornsoff)
COM_AddCommand("horndisable", hornsoff)
COM_AddCommand("hornsdisable", hornsoff)

local function hornson(p, target) -- if anyone ever uses this i'll eat my monitor
	COM_BufInsertText(p, "hornenabled on")
	p.nethornenabled = true
	CONS_Printf(p, "\131OK! \128Horns enabled: welcome back! If you need to shut them off again, use \135hornsoff\128.")
	hornlog(p,"fun enabled")
	tattle(p,"horns on")
end
COM_AddCommand("hornson", hornson)
COM_AddCommand("hornon", hornson)
COM_AddCommand("enablehorn", hornson)
COM_AddCommand("enablehorns", hornson)
COM_AddCommand("hornenable", hornson)
COM_AddCommand("hornsenable", hornson)

COM_AddCommand("horndonthelpme", function(p, target) -- provided for alias use mostly
	p.helpme = false
	CONS_Printf(p, "\131OK! \128Horn help text disabled.")
	hornlog(p,"help disabled")
end)

COM_AddCommand("hornhelpme", function(p, target) -- provided for alias use mostly
	p.helpme = true
	CONS_Printf(p, "\131OK! \128Horn help text enabled.")
	hornlog(p,"help enabled")
end)

local function hornadjust(p, target) -- xd?
	if target == "random" then
		p.targethorntype = P_RandomRange(1, #horns)
	else
		local guard = tonumber(target)
		if not guard or guard > #horns then
			CONS_Printf(p, "Why")
			return
		end
		if p.targethorntype < 1 then
			p.targethorntype = 1
		else
			p.targethorntype = (($ + target + #horns) % #horns) or #horns
		end
	end
	S_StartSound(nil, _G[horns[p.targethorntype].name], p)
	CONS_Printf(p, prettyhornname(p.targethorntype))
end
COM_AddCommand("hornadjust", hornadjust)

addHook("MapLoad", do -- when map changes, forcibly init to reset flags and reroll horns
	for p in players.iterate do
		p.hornready = nil
		if p.mo and not p.spectator
			horninit(p)
		end
	end
end)

addHook("ThinkFrame", function()
	local prerace = leveltime < starttime
	local dueling = (ks_countplayers() == 2) and hornduelmode.value
	local usinghellhorns = false
	if mapheaderinfo[gamemap].menuflags % 2 >= 1 and leveltime >= 2 * TICRATE and hornhell.value then
		usinghellhorns = true
	end
	for p in players.iterate do
		if not p.hornconfigloaded then
			COM_BufInsertText(p, "exec hornmod.cfg -noerror")
			p.hornconfigloaded = true
		end
		if p.nethornenabled == nil then
			p.nethornenabled = true -- prevents horn trigger when horns are locally disabled. can be desynced if you do it on purpose
		end
	
		if not p.mo then -- avoid fuckery with spectators
			--hornlog(p,"mo early out")
			continue
		end
		
		if not p.hornready then -- set player vars, reroll horn, etc
			hornlog(p,"init")
			horninit(p)
		end
		
		if leveltime == 2 * TICRATE and (usinghellhorns or (P_RandomRange(1,1000) <= hornhellchance.value and not p.targethorntype)) then
			S_StartSound(nil, sfx_hmhell, p)
			chatprintf(p, "\x83*A shadow passes over your item button...")
			p.horntype = P_RandomRange(1, #hellhorns)
			p.usinghellhorns = true
		end
	
		if not p.noisemaker then -- time to spawn an invisible horn container
			hornlog(p,"no noisemaker, spawning")
			spawnnoisemaker(p)
		elseif not p.noisemaker.valid then
			hornlog(p,"invalid noisemaker, spawning") -- i'm not actually sure when this happens but i saw it once lol
			spawnnoisemaker(p)
		end
		
		if p.cmd.buttons & BT_ATTACK then -- input handling, idiot edition
			p.horninput = $ + 1 -- at some point i feel like making an easter egg for holding this
		else
			p.horninput = 0
        end
		
		p.hornok = false; -- is horn OK right now?
		local hornoffset = 0; -- HORRIBLE TERRIBLE NO GOOD VOLUME HACK BECAUSE S_StartSoundAtVolume DOESN'T WORK
		if p.exiting then -- always OK postrace, because i am a shithead
			p.hornok = true
			p.horncount = 0 -- postrace explosions causing massive lag lol
			p.finishedfor = $ + 1
			if p.kartstuff[k_position] ~= 1 then
				hornoffset = hornattenuate.value -- you didn't win, so shut the fuck up
			end
		else -- must be alive and item box must be fully empty
			p.hornok = p.playerstate == PST_LIVE and not p.lastframeroulette and not p.lastframeitem and not p.lastframeheld and not p.lastframeeggmanheld and not p.lastframesneaker and not p.kartstuff[k_eggmanexplode] -- HAHAHAHAHAHA
		end
		
		 -- THE NOISEMAKER HELL BLOCK
		local destx = p.mo.x
		local desty = p.mo.y
		local destz = p.mo.z + (40*p.mo.scale)
		p.noisemaker.eflags = $ & (~MFE_VERTICALFLIP)
		if p.mo.eflags & MFE_VERTICALFLIP then
			destz = p.mo.z -- FUDGE FACTOR, DON'T CARE. NO IDEA HOW THIS WORKS
			p.noisemaker.eflags = $|MFE_VERTICALFLIP
		end
		p.noisemaker.color = p.mo.color
		p.noisemaker.colorized = true
		p.noisemaker.destscale = p.mo.scale
		p.noisemaker.scalespeed = FixedDiv(p.mo.scale, 8*FRACUNIT)
		
		if p.shakefactor > 0 then
			p.shakefactor = max($ - (p.shakefactor / 12), 0)
		else
			p.shakefactor = 0
		end
		local shake = min((max(p.shakefactor, 10) - 10) / 3, 15)
		--destx = $ + FixedMul(P_RandomRange(-1 * shake, shake) * FRACUNIT, sin(p.mo.angle)) -- shake shake
		--desty = $ + FixedMul(P_RandomRange(-1 * shake, shake) * FRACUNIT, cos(p.mo.angle)) * FRACUNIT -- shake shake
		destx = $ + P_RandomRange(-1 * shake, shake) * p.mo.scale -- shake shake
		desty = $ + P_RandomRange(-1 * shake, shake) * p.mo.scale -- shake shake
		destz = $ + P_RandomRange(-1 * shake, shake) * p.mo.scale -- shake shake
		if (leveltime % 4) < 2 and false then
			if p.warningstate == 2 then
				p.noisemaker.color = SKINCOLOR_CRIMSON
			elseif p.warningstate == 1 then
				p.noisemaker.color = SKINCOLOR_YELLOW
			end
		end
		P_TeleportMove(p.noisemaker, destx, desty, destz)
		P_TeleportMove(p.hacknoisemaker, destx, desty, destz + hornoffset * FRACUNIT)
		
		if p.sincelasthorn > 5 and not p.seenloadmessage and p.helpme then -- this is the wrong way to do this.
			CONS_Printf(p, "\134\3* HORNMOD " .. versionname .. ", by TyroneSama *")
			CONS_Printf(p, "Use \135hornsoff\128 to disable horns from all players.")
			p.seenloadmessage = true
		end
		
		local playme = p.horntype
		if horntypeoverride.value then
			playme = horntypeoverride.value
		end
		if horntypechaos.value then
			playme = P_RandomRange(1, #horns)
		end
		local resolvedhorn = nil
		if p.usinghellhorns then
			resolvedhorn = _G[hellhorns[p.horntype].name]
		else
			resolvedhorn = _G[horns[playme].name]
		end
		
        if p.horninput == 1 and p.hornok and p.nethornenabled then
			if not dueling then
				if not prerace then
					p.horncount = $ + 1 + P_RandomRange(0, 1) -- FEAR MODE LMAO
				end
				if p.sincelasthorn >= (TICRATE / 2) then
					p.horncount = $ + 1 -- long horns spammed slowly get a minor extra penalty
				end
				p.sincelasthorn = 0
				p.lifetimehorncount = $ + 1
			end
			p.shakefactor = p.shakefactor + 10
			if hornenabled.value then
				S_StopSound(p.hacknoisemaker)
				P_SetScale(p.noisemaker, FixedMul(p.mo.scale, FixedDiv(5*FRACUNIT, 4*FRACUNIT)))
				if hornvisual.value then
					p.hornflash = 6
				end
				if p.horncount > hornlethal.value or prerace then -- local only horn when past DEATH MODE or pre-start
					hornlog(p,"local horn, hc:" .. p.horncount)
					S_StartSound(p.hacknoisemaker, resolvedhorn, p)
				else
					hornlog(p,"real horn, hc:" .. p.horncount)
					S_StartSound(p.hacknoisemaker, resolvedhorn)			
				end
				if hornobnoxious.value then
					if p.horncount >= horndanger.value and p.warningstate < 2 then -- okay really now
						S_StartSoundAtVolume(nil, sfx_hmdang, 255, p)
						S_StartSoundAtVolume(nil, sfx_s3k50, 160, p)
						p.warningstate = 2
					elseif p.horncount >= hornwarning.value and p.warningstate < 1 then -- gentle nudge
						S_StartSoundAtVolume(nil, sfx_hmwarn, 255, p)
						S_StartSoundAtVolume(nil, sfx_s3kb2, 160, p)
						p.warningstate = 1
					end
				end
			else
				hornlog(p,"override horn, hc:" .. p.horncount)
			end
        end
		
		if S_SoundPlaying(p.hacknoisemaker, resolvedhorn) and ((leveltime % 2) or p.hornflash == 0 or true) then
			p.noisemaker.flags2 = $ & (~MF2_DONTDRAW)
		else
			p.noisemaker.flags2 = $|MF2_DONTDRAW
		end
		
		if p.horncount >= hornlethal.value and hornobnoxious.value then -- gotta die outside of the horn block to not desync
			hornlog(p,"your honor,")
			p.markedfordeath = true
		end

		if p.markedfordeath and not p.kartstuff[k_spinouttimer] and P_IsObjectOnGround(p.mo) then -- delays death if items are involved to avoid spinout skips
			hornlog(p,"league of legends") -- side note: this is actually more restrictive than the respawn command!
			tattle(p,"mash death")
			S_StartSound(nil, sfx_cdfm73, p)
			if not p.alreadyexploded and hornexplosions.value then -- controls rapid explosion spam
				S_StartSound(p.mo, sfx_kc3b)
				K_SpawnMineExplosion(p.mo, p.skincolor)
			end
			if (hitfeed) then HF_SendHitMessage(nil, p, "K_HORNHF", p.skincolor) end
			P_DamageMobj(p.mo, nil, nil, 10000)
			S_StopSound(p.noisemaker)
			S_StopMusic(p)
			p.horncount = 0
			p.warningstate = 0
			p.alreadyexploded = true
			p.lifetimeexplodecount = $ + 1
			if p.lifetimeexplodecount >= hornmaxexplosions.value then
				COM_BufInsertText(p, "quit") -- go somewhere else.
			end
			if hornfinaldeath.value then
				COM_BufInsertText(server, 'kick "' .. #p .. '" FINAL DEATH')
			end
			p.markedfordeath = false -- THIS IS IMPORTANT.
		end
		
		if p.hornflash > 0 and not p.mo.colorized then -- little visual indicator for who's mashing horn
			if p.hornflash%2 then -- HAHA I DON'T INTO GRAPHICS SO JUST PALETTE FLASH INSTEAD LOL
				-- p.mo.color = p.skincolor
				-- p.mo.colorized = false
			else
				if p.skincolor == SKINCOLOR_YELLOW then
					-- p.mo.color = SKINCOLOR_GOLD
				else
					-- p.mo.color = SKINCOLOR_YELLOW
				end
				-- p.mo.colorized = true
			end
			p.hornflash = $ - 1
		end
        
        p.lastframeitem = p.kartstuff[k_itemtype] -- update next frame's item information
        p.lastframeroulette = p.kartstuff[k_itemroulette]
		p.lastframeheld = p.kartstuff[k_itemheld]
		p.lastframeeggmanheld = p.kartstuff[k_eggmanheld]
		p.lastframesneaker = p.kartstuff[k_rocketsneakertimer]
        
		-- DOWN HERE TOO, IDIOT
		if p.sincelasthorn < 2 then 
			p.noisemaker.color = SKINCOLOR_YELLOW
		end
		
		p.sincelasthorn = $ + 1 -- reset flood protection when backing off
        if p.sincelasthorn > ((hornwarningreset.value + p.shutupidiot) * 35) and p.horncount > 0 then
			hornlog(p,"horncount reset")
			if p.horncount >= horndanger.value then
				p.shutupidiot = $ * 3 + 1
			end
            p.horncount = 0
			p.warningstate = 0
        end
		
		if p.horncount <= hornwarning.value then -- because one layer of idiot protection simply isn't enough
			p.sincelastwarning = $ + 1
		else
			p.sincelastwarning = 0
		end
		if p.sincelastwarning > (hornwarningreset.value * 35 * 2) then -- as arbitrary as they come
			--hornlog(p,"danger reset")
			p.shutupidiot = 0
			p.alreadyexploded = 0
		end
	end
end)

addHook("PlayerMsg", function(p, type, target, msg) -- using the console is very hard
	if msg == "sethorn" or msg == "listhorns" or msg == "keephorn" then
		tattle(p,"console explainer")
		CONS_Printf(p, "\133Horn commands only work in the console, \135not in chat! \128Press \130tilde (~) \128to open it.") -- would pop an on-screen message with drawstring, but it wouldn't run during intermission iirc
		return true
	end
	return false
end)

hud.add(function(v, p, c)
	if splitscreen then  -- really, really don't feel like handling this
		return
	end
	
	if not p.hornready or not hornenabled.value then
		return
	end
	
	if horndebug.value then
		v.drawString(0, 7, "horncount: " .. p.horncount, V_ALLOWLOWERCASE, "small")
		v.drawString(0, 12, "shutupidiot: " .. p.shutupidiot, V_ALLOWLOWERCASE, "small")
		v.drawString(0, 17, "sincelastwarning: " .. p.sincelastwarning, V_ALLOWLOWERCASE, "small")
		v.drawString(0, 22, "leveltime: " .. leveltime, V_ALLOWLOWERCASE, "small")
	end
	
	if leveltime < (10 * TICRATE) and p.lifetimehorncount < 4 and hornshowtutorial.value then
		local flash = ""
		if leveltime % 10 < 5 then
			flash = "\130"
		end
		v.drawString(160, 20, "Press " .. flash .. "ITEM \128to honk!", V_ALLOWLOWERCASE, "center")
	end
	
	if p.finishedfor > 2 * TICRATE and p.helpme and hornshowhelptext.value then
		if not (p.targethorntype or p.usinghellhorns) then 
			v.drawString(0, 2, "Your horn was" .. prettyhornname(p.horntype) .. "\128.", V_ALLOWLOWERCASE, "small")
			if p.helpme then
				v.drawString(0, 7, "Type \135keephorn\128 in console to keep it, or \135sethorn\128 to pick one yourself.", V_ALLOWLOWERCASE, "small")
			end
		end
	end

    if not hornobnoxious.value then
        return
    end
    if p.markedfordeath then
		if leveltime%2 >= 1 then
			v.drawString(160, 30, "TIME TO DIE", V_REDMAP, "center")
		end
	elseif p.horncount >= horndanger.value then
		if leveltime%4 >= 2 then
			v.drawString(160, 30, "I ASKED POLITELY", V_REDMAP, "center")
			if hornfinaldeath.value then
				v.drawString(160, 40, "!! DEATH APPROACHES !!", V_YELLOWMAP, "center")
			end
		end
	elseif p.horncount >= hornwarning.value then
		if leveltime%6 >= 3 then
			v.drawString(160, 30, "EASE OFF THE HORN", V_YELLOWMAP, "center")
		end
    end
end)

rawset(_G, "HORNMOD_AddHorns", function(...) -- expects same format as the horn table up top
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		allocatenewhorn(v.name)
		table.insert(horns, v)
		print("HORNMOD: Added " .. v.name)
	end
end)

rawset(_G, "HORNMOD_AddHellHorns", function(...)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		allocatenewhorn(v.name)
		table.insert(hellhorns, v)
		print("HORNMOD: Added " .. v.name)
	end
end)